/* main.c */

#include <stm32f10x.h>
#include <stm32f10x_rcc.h>
#include <stm32f10x_gpio.h>
#include <stm32f10x_spi.h>
#include "eeprom.h"
#include <string.h>

//   3
//static uint16_t INbuff[10] = {0xFFF1,0xFFF2,0xFFF3,0xFFF4,0xFFF5,0xFFF6,0xFFF7,0xFFF8,0xFFF9,0xFFFA};
//static uint16_t OUTbuff[10] = {0};

void otherInit(void);

void Delay(uint32_t nTime);
uint8_t debounce(uint8_t last);

#define rlen 100

int main(void)
{
	uint8_t currentButton;
	uint8_t lastButton;

	uint8_t len;
	uint8_t rbuf[rlen], rs;
	//char mes[] = "The Read Status Register (RDSR) instruction provides access to the Status register.";
char mes[] = "Love is the only force capable of transforming an enemy into a friend. Martin Luther King, Jr.";

	lastButton = GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0);
	currentButton = lastButton;

	otherInit(); // Initialize user button
	eepromInit();

	// Configure SysTick Timer
	if (SysTick_Config(SystemCoreClock / 1000))
			while (1);

while (1)	{

	currentButton = debounce(lastButton);

	if ( lastButton == Bit_RESET && currentButton == Bit_SET ){


		// 1.  .
		//
		rs = eepromReadStatus(); //  

		//       
		eepromWriteEnable();

		while (WIP(rs = eepromReadStatus()));

		//       WEL
		if (WEL(rs = eepromReadStatus()))
			eepromWriteDisable(); //   
		else
			assert_failed(__FILE__, __LINE__);

		while (WIP(rs = eepromReadStatus()));

		//    eepromWriteDisable()
		if (!WEL((rs = eepromReadStatus()))){

			//   BP0 and BP1.
			eepromWriteStatus( (uint8_t)4 | 8); // BP0 | BP1
		} else
			assert_failed(__FILE__, __LINE__);

		while (WIP(rs = eepromReadStatus())); //   

		// BP0  BP1 .    - 00001100.
		if ((rs & ( 4 | 8))){ // ,   ?


			eepromWriteStatus(0x00); //   BP0  BP1
		}else
			assert_failed(__FILE__, __LINE__);

		//   WPEN
		eepromWriteStatus( (uint8_t)0x80); // 10000000
		//   WPEN
		eepromWriteStatus(0x00);
		while (WIP(rs = eepromReadStatus()));

		rs = eepromReadStatus();
		//test. end

		// 2.   
		len = (uint8_t)strlen(mes);
		eepromWrite(mes, len, 4 ); //   4

		eepromRead(rbuf, rlen, 0 ); //    x00 100 


		// 3.        DMA.
		//   INbuff  OUTbuff
		//xchng_datablock(0, 1, OUTbuff, INbuff, 10);


	}

		lastButton = currentButton;

}//while

    return 0;
}

void otherInit(void){
	GPIO_InitTypeDef GPIO_InitStructure;


	// user button A0
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA , ENABLE);
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
		GPIO_Init(GPIOA,	&GPIO_InitStructure);
}

static __IO uint32_t TimingDelay;

void Delay(uint32_t nTime){
	TimingDelay = nTime;
	while(TimingDelay != 0);
}

void SysTick_Handler(void){
	if (TimingDelay != 0x00)
		TimingDelay--;
}

uint8_t debounce(uint8_t last){
	uint8_t current = GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0);
	  if ( last != current ){
		  Delay(5);
		  current = GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0);
	  }
  return current;
}

#ifdef USE_FULL_ASSERT
void assert_failed(uint8_t *file, uint32_t line)
{
	/* Infinite loop */
	/* Use GDB to find out why we're here */
	while (1);
}
#endif
