/* spi.h */

#ifndef SPI_H_
#define SPI_H_

enum spiSpeed { SPI_SLOW, SPI_MEDIUM, SPI_FAST };

//   SPI.    SPI2.
void spiInit(SPI_TypeDef* SPIx);

// /   8 
// SPIx -  SPI2
// rbuf -   ,    
// tbuf -    

// cnt -  ( 8 )
//
//   tbuf  ,   rbuf - 0,    ,  
//      .
//   -   ,   ""  (0xff).
//     ,      .
int spiReadWrite(SPI_TypeDef* SPIx, uint8_t * rbuf, const uint8_t * tbuf, int cnt, enum spiSpeed speed);

// /   16 
// .   spiReadWrite()  (8  -> 16 )
int spiReadWrite16(SPI_TypeDef* SPIx, uint16_t * rbuf, const uint16_t * tbuf, int cnt, enum spiSpeed speed);

#endif
